fixup initial faiserver bootstrap & small bugs
[automated-distro-installer] / faiserver-setup
index 1bfbacb547e18f00fc2dd50da79f1f5615a029d8..724a09c7bce7e4182dd9d01658cb7169e9102f28 100755 (executable)
@@ -1,6 +1,24 @@
 #!/bin/bash
+# Copyright (C) 2016 Ian Kelling
 
-# initial setup of a fai server on debian
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+
+# Initial setup of a fai server on debian. works on localhost.
+# Set's the current ip as the tftp server. I vaguely remember
+# that using a hostname does not work
+# Requires changing dns to point faiserver and running fai-redep
 
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
@@ -8,14 +26,24 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 [[ $EUID == 0 ]] || exec sudo "${BASH_SOURCE}" "$@"
 
 e() { echo "$@"; "$@"; }
+
+base=${1:-jessie}
+sed="sed -ri --follow-symlinks"
+
+
+if [[ $base == jessie ]]; then
+    wget -O - http://fai-project.org/download/074BCDE4.asc | apt-key add -
+    cat >/etc/apt/sources.list.d/fai.list <<'EOF'
+deb http://fai-project.org/download jessie koeln
+EOF
+else
+    rm -f /etc/apt/sources.list.d/fai.list
+fi
+
 # for ubuntu:
 #add-apt-repository -y ppa:fai/ppa
 
 # for debian:
-wget -O - http://fai-project.org/download/074BCDE4.asc | apt-key add -
-cat >/etc/apt/sources.list.d/fai.list <<'EOF'
-deb http://fai-project.org/download jessie koeln
-EOF
 
 apt-get update
 # all the dependencies except the dhcp server
@@ -25,27 +53,48 @@ to_install=()
 for pkg in $deps; do
     dpkg -s $pkg &>/dev/null && continue ||:
     to_install+=($pkg)
-    echo $pkg >>/etc/fai/fai-manually-installed-packages
+    # just so we have a record.
+    echo `date` $pkg >>/var/log/fai-manually-installed-packages.log
 done
 if [[ $to_install ]]; then
     apt-get -y install ${to_install[@]}
 fi
 
-sed -i 's/^#deb/deb/' /etc/fai/apt/sources.list
-sed -i 's/#LOGUSER/LOGUSER/' /etc/fai/fai.conf
+r=http://http.us.debian.org/debian
+# like default, but scrap httpredir and add suggested newer pkgs in fai-project.org
+dd of=/etc/fai/apt/sources.list <<EOF
+deb $r $base main contrib non-free
+deb http://security.debian.org/debian-security $base/updates main contrib non-free
+
+EOF
+
+if [[ $base == jessie ]]; then
+    tee -a /etc/fai/apt/sources.list <<'EOF'
+deb http://fai-project.org/download jessie koeln
+EOF
+fi
+
+# tried out a stretch base, doesn't work yet.
+$sed -f - /etc/fai/nfsroot.conf <<EOF
+s,^( *FAI_DEBOOTSTRAP=).*,\1"$base $r",
+EOF
+
+$sed 's/#LOGUSER/LOGUSER/' /etc/fai/fai.conf
 # from man fai-make-nfsroot,
 # figured out after partitioning ignored my crypt partition
+
+
 if ! grep cryptsetup /etc/fai/NFSROOT &>/dev/null; then
-    sed -ri '/^PACKAGES install$/a cryptsetup' /etc/fai/NFSROOT
+    $sed '/^PACKAGES install$/a cryptsetup' /etc/fai/NFSROOT
 fi
-fai-setup -vf
+fai-setup -vf
 { head -n 1 /srv/fai/nfsroot/root/.ssh/known_hosts | awk '{print $1}' \
-        | tr '\n' ' '; ssh-keyscan localhost | grep -o "ecdsa-sha2-nistp256.*"; \
+      | tr '\n' ' '; ssh-keyscan localhost | grep -o "ecdsa-sha2-nistp256.*"; \
     } >>/srv/fai/nfsroot/root/.ssh/known_hosts
 
 # this does not alter the config on a new install
-sed -ri 's#^([[:space:]]*TFTP_DIRECTORY[[:space:]]*=).*#\1"/srv/tftp"#' \
-    /etc/default/tftpd-hpa
+$sed 's#^([[:space:]]*TFTP_DIRECTORY[[:space:]]*=).*#\1"/srv/tftp"#' \
+     /etc/default/tftpd-hpa
 
 service tftpd-hpa restart
 
@@ -60,13 +109,14 @@ service tftpd-hpa restart
 # Add debug to -f flag for more verbose output.
 
 std_arg="-u nfs://faiserver/srv/fai/config"
-fai-chboot -Iv $std_arg default # reset so we are idempotent
+fai-chboot -Iv $std_arg default # reset so we are idempotent
 kernel=$(fai-chboot -L '^default$' | awk '{print $3}')
 type -t host &>/dev/null || apt-get -y install dnsutils
+# resolve host using gateway address
 my_ip=$(host faiserver $(route -n | sed -rn 's/^(0\.){3}0\s+(\S+).*/\2/p') | \
-               sed -rn 's/^\S+ has address //p')
+            sed -rn 's/^\S+ has address //p')
 k_args=$(fai-chboot -L '^default$' | \
-                sed -r "s/^(\S+\s+){3}(.*root=)(.*)/\2$my_ip:\3/")
+             sed -r "s/^(\S+\s+){3}(.*root=)(.*)/\2$my_ip:\3/")
 e fai-chboot -k "$k_args" -v -f verbose,sshd,createvt,reboot $std_arg $kernel default
 
 # make the faiserver also the apt proxy server
@@ -89,6 +139,6 @@ apt-get -y install apt-cacher-ng
 # the logsave prompted because the hostname faiserver was uknown.
 # Here it was faiserver.lan when running from a faiserver vm.
 # When running from a normal host with faiserver alias, it was the normal hosts name.
-sed -ri 's/(^[^,]+,)\S+/\1faiserver/' /srv/fai/nfsroot/root/.ssh/known_hosts
+$sed 's/(^[^,]+,)\S+/\1faiserver/' /srv/fai/nfsroot/root/.ssh/known_hosts
 # ditch the logo banner up top which screws with less.
 touch /srv/fai/nfsroot/.nocolorlogo